// button.as

Hacker = function () {
	this.propActive = true;
	this.propAlive = true;
	this.propOlAlpha = 0;
	this.propOlRolloverAlpha = 50;
	this.propMoveVector = [];
	this.propWiggleInterval = 0;
	this.propWiggleHandle = null;

	this.propOnRelease = function () {}
}

Hacker.prototype = new MovieClip ();

// --------------------- METHODS --------------------

Hacker.prototype.getMoveVector = function () {
	return this.propMoveVector;
	ASSetPropFlags (Hacker.prototype, ['getMoveVector'], 1);
}

Hacker.prototype.setMoveVector = function (p) {
	this.propMoveVector = p;
	ASSetPropFlags (Hacker.prototype, ['setMoveVector'], 1);
}

Hacker.prototype.getAlive = function () {
	return this.propAlive;
	ASSetPropFlags (Hacker.prototype, ['getAlive'], 1);
}

Hacker.prototype.setAlive = function (p) {
	this.propAlive = p;
	ASSetPropFlags (Hacker.prototype, ['setAlive'], 1);
}

Hacker.prototype.getOlRolloverAlpha = function () {
	return this.propOlRolloverAlpha;
	ASSetPropFlags (Hacker.prototype, ['getOlRolloverAlpha'], 1);
}

Hacker.prototype.setOlRolloverAlpha = function (p) {
	this.propOlRolloverAlpha = p;
	this.i_char.i_ol._alpha = p;
	ASSetPropFlags (Hacker.prototype, ['setOlRolloverAlpha'], 1);
}

Hacker.prototype.onRollOver = function () {
	if (this.propActive && this.propAlive) {
		this.i_char.i_ol._alpha = this.propOlRolloverAlpha;
	}
	ASSetPropFlags (Hacker.prototype, ['onRollOver'], 1);
}

Hacker.prototype.onRollOut = function () {
	if (this.propActive && this.propAlive) {
		this.i_char.i_ol._alpha = 0;
	}
	ASSetPropFlags (Hacker.prototype, ['onRollOut'], 1);
}

Hacker.prototype.onReleaseOutside = function () {
	if (this.propActive && this.propAlive) {
		this.onRollOut ();
	}
	ASSetPropFlags (Hacker.prototype, ['onReleaseOutside'], 1);
}

Hacker.prototype.onRelease = function () {
	if (this.propActive && this.propAlive) {
		this.propOnRelease (this);
	}
	ASSetPropFlags (Hacker.prototype, ['onRelease'], 1);
}

Hacker.prototype.deactivate = function () {
	if (this.propAlive) {
		this.propActive = false;
		this.useHandCursor = false;
		this._alpha = 50;
		this.i_char.i_ol.alpha = 0;
	}
	ASSetPropFlags (Hacker.prototype, ['deactivate'], 1);
}

Hacker.prototype.activate = function () {
	if (this.propAlive) {
		this.propActive = true;
		this.useHandCursor = true;
		this._alpha = 100;
	}
	ASSetPropFlags (Hacker.prototype, ['activate'], 1);
}

Hacker.prototype.wiggle = function () {
	if (this.propAlive && this.propActive) {
		this.gotoAndPlay ('wiggle');
	}
	ASSetPropFlags (Hacker.prototype, ['wiggle'], 1);
}

Hacker.prototype.startWiggle = function (i) {
	this.propWiggleHandle = setInterval (this, 'wiggle', i);
	ASSetPropFlags (Hacker.prototype, ['startWiggle'], 1);
}

Hacker.prototype.endWiggle = function (i) {
	clearInterval (this.propWiggleHandle);
	ASSetPropFlags (Hacker.prototype, ['endWiggle'], 1);
}

Hacker.prototype.advance = function () {
	this.gotoAndPlay ('advance');
	ASSetPropFlags (Hacker.prototype, ['advance'], 1);
}

Hacker.prototype.kill = function () {
	clearInterval (this.propWiggleHandle);
	this.gotoAndPlay ('die');
	this.useHandCursor = false;
	this.propAlive = false;
	ASSetPropFlags (Hacker.prototype, ['kill'], 1);
}


//  ---------------- PROPERTIES -----------------

Hacker.prototype.addProperty ('alive', Hacker.prototype.getAlive, Hacker.prototype.setAlive);
Hacker.prototype.addProperty ('olColors', Hacker.prototype.getOlColors, Hacker.prototype.setOlColors);


Object.registerClass ('m_hackerAnim', Hacker);
